<?php
//session handling information please!
include("../misc/agenda.php");
include("../misc/aux.php");
include("../primitives/atom.php");
include("../primitives/fact.php");
include("../primitives/variable.php");
include("../primitives/rule.php");
include("../primitives/match.php");
include("../knowledgeBase.php");
include("../parser.php");
include("../jtms/jtms.php");
include("../jtms/jtmsNode.php");

session_start();
header("Cache-control: private"); //IE 6 fix

$_SESSION["agenda"]->pop();

$_SESSION["seen"]["originality.php"] = true;

clearSessionVariables();
handleGeneral();

$_SESSION["history"][] = "originality.php";
$url = $_SESSION["agenda"]->peek();
//$url = "originality.php";
echo("<meta http-equiv=\"refresh\" content=\"0;url=$url\">");

function clearSessionVariables(){
	if(isset($_SESSION["facts"]["originalityHandler.php"])){
		foreach($_SESSION["facts"]["originalityHandler.php"] as $fact){
			$_SESSION["kb"]->retract_fact($fact);
		}
	}
	unset($_SESSION["OriginalityMotivation"]);
	unset($_SESSION["PaperOriginality"]);
	unset($_SESSION["PreviouslyPublished"]);
	unset($_SESSION["PreviousSimilar"]);
	unset($_SESSION["OriginalitySystems"]);
	unset($_SESSION["OriginalityProblem"]);
}

function handleGeneral(){
	if(isset($_POST["originality"])){
		if($_POST["paperOriginality"] == -1){
			$_SESSION["PaperOriginality"] = 0;
		}
		else{
			$_SESSION["PaperOriginality"] = $_POST["originality"];
			if($_SESSION["PaperOriginality"] == 1){
				$fact = new fact("original", Array(new atom("excellent")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PaperOriginality"] == 2){
				$fact = new fact("original", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PaperOriginality"] == 3){
				$fact = new fact("original", Array(new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PaperOriginality"] == 4){
				$fact = new fact("original", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
		}
	}
	if(isset($_POST["originalityMotivation"])){
		$_SESSION["OriginalityMotivation"] = $_POST["originalityMotivation"];
	}
	if(isset($_POST["previouslyPublished"])){
		if($_POST["previouslyPublished"] == -1){
			$_SESSION["PreviouslyPublished"] = 0;
		}
		else{
			$_SESSION["PreviouslyPublished"] = $_POST["previouslyPublished"];
			if($_SESSION["PreviouslyPublished"] == 1){	
				$fact = new fact("previouslyPublished", Array(new atom("yes")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PreviouslyPublished"] == 2){	
				$fact = new fact("previouslyPublished", Array(new atom("previousVersion")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PreviouslyPublished"] == 3){	
				$fact = new fact("previouslyPublished", Array(new atom("update")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PreviouslyPublished"] == 4){	
				$fact = new fact("previouslyPublished", Array(new atom("no")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
		}
	}
	if(isset($_POST["previousSimilar"])){
		if($_POST["previousSimilar"] == -1){
			$_SESSION["PreviousSimilar"] = 0;
		}
		else{
			$_SESSION["PreviousSimilar"] = $_POST["previousSimilar"];
			if($_SESSION["PreviousSimilar"] == 1){
				$fact = new fact("similarWork", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PreviousSimilar"] == 2){
				$fact = new fact("similarWork", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
			elseif($_SESSION["PreviousSimilar"] == 2){
				$fact = new fact("similarWork", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
				$fact = new fact("similarWork", Array(new atom("isolated")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;	
			}
		}
	}
	if(isset($_POST["originalitySystems"])){
		if($_POST["originalitySystems"] == -1){
			$_SESSION["OriginalitySystems"] = 0;
		}
		else{
			$_SESSION["OriginalitySystems"] = $_POST["originalitySystems"];
			if($_SESSION["OriginalitySystems"] == 1){
				$fact = new fact("previousSystems", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
			elseif($_SESSION["OriginalitySystems"] == 2){
				$fact = new fact("previousSystems", Array(new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
			elseif($_SESSION["OriginalitySystems"] == 3){
				$fact = new fact("previousSystems", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
		}
	}
		if(isset($_POST["originalityProblem"])){
		if($_POST["originalityProblem"] == -1){
			$_SESSION["OriginalityProblem"] = 0;
		}
		else{
			$_SESSION["OriginalityProblem"] = $_POST["originalityProblem"];
			if($_SESSION["OriginalityProblem"] == 1){
				$fact = new fact("problemOriginality", Array(new atom("excellent")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
			elseif($_SESSION["OriginalityProblem"] == 2){
				$fact = new fact("problemOriginality", Array(new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
			elseif($_SESSION["OriginalityProblem"] == 3){
				$fact = new fact("problemOriginality", Array(new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
			elseif($_SESSION["OriginalityProblem"] == 4){
				$fact = new fact("problemOriginality", Array(new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["originalityHandler.php"][] = $fact;		
			}
		}
	}
}


?>