<?php
//session handling information please!

include("../misc/agenda.php");
include("../misc/aux.php");
include("../primitives/atom.php");
include("../primitives/fact.php");
include("../primitives/variable.php");
include("../primitives/rule.php");
include("../primitives/match.php");
include("../knowledgeBase.php");
include("../parser.php");
include("../jtms/jtms.php");
include("../jtms/jtmsNode.php");

session_start();
header("Cache-control: private"); //IE 6 fix

$_SESSION["seen"]["technique.php"] = true;

if(isset($_GET["TechniqueNumber"])){
	$TN = $_GET["TechniqueNumber"];	
}

$_SESSION["agenda"]->pop();
clearSessionVariables($TN);
handleNaturalSystem($TN);
handleTechniqueAge($TN);
handleGeneral($TN);

$_SESSION["history"][] = "technique.php?TechniqueNumber=" . $TN;
$url = $_SESSION["agenda"]->peek();
echo("<meta http-equiv=\"refresh\" content=\"0;url=$url\">");

function clearSessionVariables($TN){
	
	if(isset($_SESSION["facts"]["techniqueHandler.php"][$TN])){
		foreach($_SESSION["facts"]["techniqueHandler.php"][$TN] as $fact){
			$_SESSION["kb"]->retract_fact($fact);
		}
	}
	
	unset($_SESSION["facts"]["summaryHandler.php"]);
	unset($_SESSION["error"]);
	unset($_SESSION["NaturalSystem"][$TN]);
	unset($_SESSION["NaturalDescriptions"][$TN]);
	unset($_SESSION["TechniqueNew"][$TN]);
	unset($_SESSION["TechniqueProblems"][$TN]);
	unset($_SESSION["RivalTechniques"][$TN]);
	unset($_SESSION["TechniqueExtensions"][$TN]);
	unset($_SESSION["TechniqueExtensionSubstantial"][$TN]);
	unset($_SESSION["PreviousApplications"][$TN]);
	unset($_SESSION["PreviousSimilar"][$TN]);
	unset($_SESSION["RivalTechniqueAdvantages"][$TN]);
	unset($_SESSION["CombinedQuantity"][$TN]);
}

function handleGeneral($TN){
	if(isset($_POST["techniqueProblem"])){
		$_SESSION["TechniqueProblems"][$TN] = $_POST["techniqueProblem"];
	}	
	if(isset($_POST["rivalTechniques"])){
		$_SESSION["RivalTechniques"][$TN] = $_POST["rivalTechniques"];	
	}
	if(isset($_POST["techniqueExtend"])){
		$_SESSION["TechniqueExtensions"][$TN] = $_POST["techniqueExtend"];	
	}
	if(isset($_POST["substantialRadio"])){
		$_SESSION["TechniqueExtensionSubstantial"][$TN] = $_POST["substantialRadio"];
		if($_SESSION["TechniqueExtensionSubstantial"][$TN] == "yes"){
			$fact = new fact("substantialChange", Array(new atom($TN)));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;	
		}
	}
	if(isset($_POST["previousApplication"])){
		$_SESSION["PreviousApplications"][$TN] = $_POST["previousApplication"];	
	}
	if(isset($_POST["applicable"])){
		if($_POST["applicable"] != -1){
			$_SESSION["TechniqueApplicable"][$TN] = $_POST["applicable"];
			if($_SESISON["TechniqueApplicable"][$TN] == 1){
				$fact = new fact("techniqueApplicable", Array(new atom($TN), new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;	
			}
			elseif($_SESISON["TechniqueApplicable"][$TN] == 2){
				$fact = new fact("techniqueApplicable", Array(new atom($TN), new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;	
			}
			elseif($_SESSION["TechniqueApplicable"][$TN] == 3){
				$fact = new fact("techniqueApplicable", Array(new atom($TN), new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;	
			}
		}
	}
	if(isset($_POST["previousSimilar"])){
		$_SESSION["PreviousSimilar"][$TN] = $_POST["previousSimilar"];
		if($_SESSION["PreviousSimilar"][$TN] == 1){
			$fact = new fact("problemSimilarity", Array(new atom($TN), new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
		elseif($_SESSION["PreviousSimilar"][$TN] == 2){
			$fact = new fact("problemSimilarity", Array(new atom($TN), new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
		elseif($_SESSION["PreviousSimilar"][$TN] == 3){
			$fact = new fact("problemSimilarity", Array(new atom($TN), new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
	}
	for($i = 1; $i < 11; $i++){
		$string1 = "rivalTechniqueName" . $i;
		$string2 = "advantages" . $i;
		$string3 = "componentTechniqueName" . $i;
		if(isset($_POST[$string1])){
			$_SESSION["RivalTechniqueNames"][$TN][$i] = $_POST[$string1];	
		}
		if(isset($_POST[$string2])){
			$_SESSION["RivalTechniqueAdvantages"][$TN][$i] = $_POST[$string2];	
			if($_SESSION["RivalTechniqueAdvantages"][$TN][$i] == 1){
				$fact = new fact("rivalAdvantages", Array(new atom($TN), new atom($i), new atom("excellent")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
			}
			elseif($_SESSION["RivalTechniqueAdvantages"][$TN][$i] == 2){
				$fact = new fact("rivalAdvantages", Array(new atom($TN), new atom($i), new atom("good")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
			}
			elseif($_SESSION["RivalTechniqueAdvantages"][$TN][$i] == 3){
				$fact = new fact("rivalAdvantages", Array(new atom($TN), new atom($i), new atom("average")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
			}
			elseif($_SESSION["RivalTechniqueAdvantages"][$TN][$i] == 4){
				$fact = new fact("rivalAdvantages", Array(new atom($TN), new atom($i), new atom("poor")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
			}
			elseif($_SESSION["RivalTechniqueAdvantages"][$TN][$i] == 5){
				$fact = new fact("rivalAdvantages", Array(new atom($TN), new atom($i), new atom("awful")));
				$_SESSION["kb"]->add_fact($fact);
				$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
			}
			
		}
		if(isset($_POST[$string3])){
			$_SESSION["ComponentTechniqueNames"][$TN][$i] = $_POST[$string3];	
		}
	}
	if(isset($_POST["combinedQuantity"])){
		$_SESSION["CombinedQuantity"][$TN] = $_POST["combinedQuantity"];
	}
}

function handleNaturalSystem($TN){
	if(isset($_POST["naturalRadio"])){
		$_SESSION["NaturalSystem"][$TN] = $_POST["naturalRadio"];
		if($_SESSION["NaturalSystem"][$TN] == "yes"){
			$fact = new fact("techniqueNaturalSystem", Array(new atom($TN)));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
	}
	if(isset($_POST["naturalDescription"])){
		//echo("Setting NaturalDescriptions $TN to ");
		//echo($_POST["naturalDescription"]);
		$_SESSION["NaturalDescriptions"][$TN] = $_POST["naturalDescription"];	
	}
}

function handleTechniqueAge($TN){
	if(isset($_POST["techniqueNew"])){
		$_SESSION["TechniqueNew"][$TN] = $_POST["techniqueNew"];
		if($_SESSION["TechniqueNew"][$TN] == 1){
			$fact = new fact("techniqueType", Array(new atom($TN), new atom("new")));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
		elseif($_SESSION["TechniqueNew"][$TN] == 2){
			$fact = new fact("techniqueType", Array(new atom($TN), new atom("extension")));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
		if($_SESSION["TechniqueNew"][$TN] == 3){
			$fact = new fact("techniqueType", Array(new atom($TN), new atom("application")));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
		if($_SESSION["TechniqueNew"][$TN] == 4){
			$fact = new fact("techniqueType", Array(new atom($TN), new atom("combination")));
			$_SESSION["kb"]->add_fact($fact);
			$_SESSION["facts"]["techniqueHandler.php"][$TN][] = $fact;
		}
	}	
}
?>