<?php
//session handling information please!
include("../misc/agenda.php");
include("../misc/aux.php");
include("../primitives/atom.php");
include("../primitives/fact.php");
include("../primitives/variable.php");
include("../primitives/rule.php");
include("../primitives/match.php");
include("../knowledgeBase.php");
include("../parser.php");
include("../jtms/jtms.php");
include("../jtms/jtmsNode.php");

session_start();
header("Cache-control: private"); //IE 6 fix

$_SESSION["lookup"][1] = "Excellent";
$_SESSION["lookup"][2] = "Good";
$_SESSION["lookup"][3] = "Average";
$_SESSION["lookup"][4] = "Poor";
$_SESSION["lookup"][5] = "Awful";

$_SESSION["kb"]->modus_ponens();

renderHeader();
renderSpacer();
renderIntro();
renderSpacer();
renderSummary();
renderSpacer();
renderRelevance();
renderSpacer();
renderOriginality();
renderSpacer();
renderValidity();
renderSpacer();
renderSignificance();
renderSpacer();
presentationLogic();
renderPresentation();
renderSpacer();

renderFooter();

function renderHeader(){
	if(isset($_GET["back"]) && $_GET["back"] == "true"){
		$_SESSION["history"] = array_slice($_SESSION["history"], 0, count($_SESSION["history"]) - 1);
		$_SESSION["agenda"]->enqueue($_ENV['HTTP_REFERER']);
	}
	
	
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE>ERA4: Final Review</TITLE>
<META NAME="Generator" CONTENT="EditPlus">
<META NAME="Author" CONTENT="D Crighton">
<META NAME="Keywords" CONTENT="">
<META NAME="Description" CONTENT="">
<link rel="stylesheet" href="style.css" type="text/css"> 

</HEAD>

<BODY>
<div id = "header">
<img src = "./images/logo.gif"/>
</div>

<div id="wrapper">

	<div id = "container">
		<div id = "content">
		<?	
}

function renderFooter(){
	?>
				<div align="right">
			<?
	if(isset($_SESSION["history"])){
		$link = $_SESSION["history"][count($_SESSION["history"]) - 1];
		$temp = parse_url($link);
		$query = $temp["query"];
		if($query == ""){
			$link = $link . "?back=true";
		}
		else{
			$link = $link . "&back=true";
		}
		echo("<a href = \"");
		echo($link);
		echo("\">Back</a>");
	}
			?>
			</div>
	</div>
</div>

	<div id = "sidebar">
		Menu
		<br><br><a href = "destroy.php">Destroy Session</a>
	</div>
	<div class="clearing">&nbsp;</div>
	</div>
</div>

	<div id = "footer">
	<a href = "mailto:crighton@gmail.com">Dave Crighton</a>: MSc Student<br>
	<a href = "http://www.inf.ed.ac.uk">School of Informatics</a><br>
	University of Edinburgh<br>
	</div>


</BODY>
</HTML>
<?
}

function renderSpacer(){
	echo("<br><br>");
}



function renderIntro(){
	?>
	<table border = "1"><td colspan = "2"><h2>General Information</h2></td></tr>
	<?
	if(isset($_SESSION["paperName"])){
		echo("<tr><td><b>Paper Name:</b></td><td>");
		echo($_SESSION["paperName"]);
		echo("</td></tr>");
	}
	if(isset($_SESSION["authorName"])){
		echo("<tr><td><b>Author:</b></td><td>");
		echo($_SESSION["authorName"]);
		echo("</td></tr>");
	}
	if(isset($_SESSION["reviewerName"])){
		echo("<tr><td><b>Reviewed by:</b></td><td>");
		echo($_SESSION["reviewerName"]);
		echo("</td></tr>");
	}
	if(isset($_SESSION["PublicationTitle"])){
		echo("<tr><td><b>For inclusion in:</b></td><td>");
		echo($_SESSION["PublicationTitle"]);
		echo("</td></tr>");
	}
	echo("</table>");
}

function renderValidity(){
	?>
	<table border = "1"><tr><td colspan = "3"><h2>Validity</h2></td></tr>
	<?
	if(isset($_SESSION["InformalArguments"])){
		$lookup[1] = "No gaps of faults";
		$lookup[2] = "Only minor gaps or faults";
		$lookup[3] = "Many or major gaps or faults";
		echo("<tr><td><b>Informal Arguments have:</b></td><td>");
		echo($lookup[$_SESSION["InformalArguments"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["Terminology"])){
		$lookup[1] = "Consistently and correctly";
		$lookup[2] = "Pell but with a few inconsistencies";
		$lookup[3] = "Poorly with major inconsistencies or inaccuracies";
		echo("<tr><td><b>Terminology is used:</b></td><td>");
		echo($lookup[$_SESSION["Terminology"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["UnjustifiedAssertions"])){
		$lookup[1] = "No";
		$lookup[2] = "Some unimportant assumptions are not justified";
		$lookup[3] = "Major assumptions are not justified";
		echo("<tr><td><b>Are there unjustified assertions present?:</b></td><td>");
		echo($lookup[$_SESSION["UnjustifiedAssertions"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["Algorithms"])){
		$lookup[1] = "There are no algorithms";
		$lookup[2] = "There are algorithms with no mistakes";
		$lookup[3] = "There are algorithms with minor errors";
		$lookup[4] = "There are algorithms with major errors";
		echo("<tr><td><b>Are any algorithms presented free from errors?:</b></td><td>");
		echo($lookup[$_SESSION["Algorithms"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["Examples"])){
		$lookup[1] = "There are no examples";
		$lookup[2] = "There are examples which are consistent with the technical body of the work";
		$lookup[3] = "There are minor errors or inconsistencies in examples";
		$lookup[4] = "There are major errors and inconsistencies in examples";
		echo("<tr><td><b>Are examples consistent with the technical body of the work?:</b></td><td>");
		echo($lookup[$_SESSION["Examples"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["Maths"])){
		$lookup[1] = "Correct and consistent with any algorithms presented";
		$lookup[2] = "Mostly correct but with some minor errors";
		$lookup[3] = "Mostly incorrect or have fundamental flaws";
		echo("<tr><td><b>Mathmatical or logical proofs are:</b></td><td>");
		echo($lookup[$_SESSION["Maths"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["ExperimantalJustifications"])){
		$lookup[1] = "Yes";
		$lookup[2] = "Some unimportant claims are unjustified";
		$lookup[3] = "Major claims are unjustified";
		echo("<tr><td><b>Does this paper justify all conclusion drawn from experimental work?:</b></td><td>");
		echo($lookup[$_SESSION["ExperimantalJustifications"]]);
		echo("</td><td>User selected</td></tr>");
	}
	if(isset($_SESSION["Techniques"]) && $_SESSION["Techniques"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>Techniques</b></td></tr>");
		for($x = 1; $x < $_SESSION["TechniqueQuantity"]; $x++){
			if(isset($_SESSION["EvalEvidenceTechnique"][$x])){
				$lookup[1] = "Yes";
				$lookup[2] = "Some evaluation but not thorough";
				$lookup[3] = "No evaluation";
				echo("<tr><td><b>Is there evidence of thorough evaluation of technique $x (");
				echo($_SESSION["TechniqueNames"][$x]);
				echo("?:</b></td><td>");
				echo($lookup[$_SESSION["EvalEvidenceTechnique"][$x]]);
				echo("</td><td>User selected</td></tr>");
			}
			if(isset($_SESSION["EvalSoundTechnique"][$x])){
				$lookup[1] = "Yes, it is sound";
				$lookup[2] = "It has some problems";
				$lookup[3] = "No, it is unsound";
				echo("<tr><td><b>Is the approach taken in evaluation of technique $x (");
				echo($_SESSION["TechniqueNames"][$x]);
				echo(" sound?:</b></td><td>");
				echo($lookup[$_SESSION["EvalSoundTechnique"][$x]]);
				echo("</td><td>User selected</td></tr>");
			}
			if(isset($_SESSION["EvalProbTechnique"][$x])){
				$lookup[1] = "Yes, it is an excellent solution";
				$lookup[2] = "It is a solution but not a good one";
				$lookup[3] = "No, it is not a solution";
				echo("<tr><td><b>Technique $x (");
				echo($_SESSION["TechniqueNames"][$x]);
				echo(" solves the problem; ");
				echo($_SESSION["TechniqueProblems"][$x]);
				echo(", is it a good solution?:</b></td><td>");
				echo($lookup[$_SESSION["EvalProbTechnique"][$x]]);
				echo("</td><td>User selected</td></tr>");
			}
		}
	}
	if(isset($_SESSION["System"]) && $_SESSION["System"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>System</b></td></tr>");
		if(isset($_SESSION["SystemUserEval"])){
			$lookup[1] = "Yes";
			$lookup[2] = "Some evaluation but not thorough";
			$lookup[3] = "No evaluation";
			echo("<tr><td><b>Is there evidence of thorough evaluation of the system(");
			echo($_SESSION["System Name"]);
			echo(", both internal and with end users, if appropriate?:</b></td><td>");
			echo($lookup[$_SESSION["SystemUserEval"]]);
			echo("</td><td>User selected</td></tr>");
		}
		if(isset($_SESSION["SystemSoundEval"])){
			$lookup[1] = "Yes, it is sound";
			$lookup[2] = "It has some problems";
			$lookup[3] = "No, it is unsound";
			echo("<tr><td><b>Is the approach taken in evaluation the system (");
			echo($_SESSION["SystemName"]);
			echo(" sound?:</b></td><td>");
			echo($lookup[$_SESSION["SystemSoundEval"]]);
			echo("</td><td>User selected</td></tr>");
		}
		if(isset($_SESSION["SystemGoodEval"])){
			$lookup[1] = "It is a good system";
			$lookup[2] = "It has some minor flaws";
			$lookup[3] = "It has major flaws";
			echo("<tr><td><b>Do the results of the evaluation (if any) suggest that the system (");
			echo($_SESSION["SystemName"]);
			echo(" is 'good', or does it have paricular weaknesses?:</b></td><td>");
			echo($lookup[$_SESSION["SystemGoodEval"]]);
			echo("</td><td>User selected</td></tr>");
		}
		if(isset($_SESSION["ToolsQuantity"])){
			echo("<tr><td colspan = \"3\"><b>Tools used in this system</b></td></tr>");
			for($x = 1; $x < $_SESSION["ToolsQuantity"] + 1; $x++){
				if(isset($_SESSION["ToolSuited"][$x])){
					$lookup[1] = "Very well suited";
					$lookup[2] = "Quite well suited";
					$lookup[3] = "It was a reasonable choice";
					$lookup[4] = "Not very well suited";
					$lookup[5] = "A poor choice";
					echo("<tr><td><b>How well suited is tool $x (");
					echo($_SESSION["ToolNames"][$x]);
					echo(") for its role in this sytem?</b></td><td>");
					echo($lookup[$_SESSION["ToolSuited"][$x]]);
					echo("</td><td>User selected</td></tr>");
				}
			}
		}
		if(isset($_SESSION["SurveyOmmisions"]) && $_SESSION["SurveyOmmisions"] == "yes"){
			echo("<tr><td colspan = \"3\"><b>Literature Survey</b></td></tr>");
			echo("<tr><td><b>There were the following notable ommissions in the Literature review:</b></td><td colspan = \"2\">");
			echo($_SESSION["SurveyOmitDescription"]);
			echo("</td></tr>");
		}
	}
	echo("</table>");
}

function renderSummary(){
	?>
	<table border = "1"><tr><td colspan = "3"><h2>Summary</h2></td></tr>
	<?
	if(isset($_SESSION["Techniques"]) && $_SESSION["Techniques"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>This paper describes the following techniques</b></td></tr>");
		for($x = 1; $x < $_SESSION["TechniqueQuantity"] + 1; $x++){
			echo("<tr><td><b>Technique $x</b></td><td><i>Name</i></td><td>");
			echo($_SESSION["TechniqueNames"][$x]);
			echo("</td></tr>");
			echo("<tr><td></td><td><i>Is a solution to the problem:</i></td><td>");
			echo($_SESSION["TechniqueProblems"][$x]);
			echo("</td></tr>");
			if(isset($_SESSION["NaturalSystem"][$x]) && $_SESSION["NaturalSystem"][$x] == "yes"){
				echo("<tr><td></td><td><i>Is a solution to the problem:</i></td><td>");
				echo($_SESSION["NaturalDescriptions"][$x]);
				echo("</td></tr>");
			}
			if(isset($_SESSION["TechniqueNew"][$x])){
				if($_SESSION["TechniqueNew"][$x] == 1){
					echo("<tr><td></td><td><i>This technique is:</i></td><td>New</td>");
				}
				
				if($_SESSION["TechniqueNew"][$x] == 2){
					echo("<tr><td></td><td><i>This technique is:</i></td><td>An extension or adaption of the technique: ");
					echo($_SESSION["TechniqueExtensions"][$x]);
					echo("</td></tr>");
				}
				
				if($_SESSION["TechniqueNew"][$x] == 3){
					echo("<tr><td></td><td><i>This technique is:</i></td><td>An an application of an existing technique to the new problem of: ");
					echo($_SESSION["PreviousApplications"][$x]);
					echo("</td></tr>");
				}
				
				if($_SESSION["TechniqueNew"][$x] == 4){
					echo("<tr><td></td><td><i>This technique is:</i></td><td>A combination of the following techniques to for one hybrid technique:");
					echo("<table>");
					for($p = 1; $p < $_SESSION["CombinedQuantity"][$x] + 1; $p++){
						echo("<tr><td>");
						echo($_SESSION["ComponentTechniqueNames"][$x][$p]);
						echo("</td></tr>");
					
					}
					echo("</table>");
					echo("</td></tr>");
				}
			}
			if(isset($_SESSION["RivalTechniques"][$x]) && $_SESSION["RivalTechniques"][$x] > 0){
				echo("<tr><td></td><td><i>The following rivals exist for this technique:</i></td><td>");
				echo("<table>");
					for($p = 1; $p < $_SESSION["RivalTechniques"][$x] + 1; $p++){
						echo("<tr><td>");
						echo($_SESSION["RivalTechniqueNames"][$x][$p]);
						echo("</td></tr>");
					
					}
					echo("</table>");
				echo("</td></tr>");
			}
			
		}
	}
	if(isset($_SESSION["System"]) && $_SESSION["System"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>This paper describes the following system</b></td><tr>");
		echo("<tr><td></td><td><i>System Name:</i></td><td>");
		echo($_SESSION["SystemName"]);
		echo("</td></tr>");
		echo("<tr><td></td><td><i>System Description</i></td><td>");
		echo($_SESSION["SystemDescription"]);
		echo("</td></tr>");
		if(isset($_SESSION["SystemType"])){
			if($_SESSION["SystemType"] == 1){
				echo("<tr><td></td><td><i>This system is:</i></td><td>Completely new</td></tr>");
				echo("<tr><td></td><td><i>This system offers the following advantages over competing approaches:</i></td><td>");
				echo($_SESSION["SystemAdvantages"]);
				echo("</td></tr>");
			}
			if($_SESSION["SystemType"] == 2){
				echo("<tr><td></td><td><i>This system is:</i></td><td>A combination of the following tools:");
				echo("<table><tr><td><u>Name</u></td><td><u>Use</u></td></tr>");
				for($p = 1; $p < $_SESSION["ToolsQuantity"] + 1; $p++){
					echo("<tr><td>");
					echo($_SESSION["ToolNames"][$p]);
					echo("</td><td>");
					echo($_SESSION["ToolDescriptions"][$p]);
					echo("</td></tr>");
				}
				echo("</table>");
				echo("</td></tr>");
			}
			if($_SESSION["SystemType"] == 1){
				echo("<tr><td></td><td><i>This system is:</i></td><td>An update of the system:<br>");
				echo($_SESSION["PreviousSystemName"]);
				echo("<br>by:<br>");
				echo($_SESSION["PreviousSystemAuthor"]);
				echo("</td></tr>");
			}
		}
	}
	
	if(isset($_SESSION["Problem"]) && $_SESSION["Problem"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>This paper describes a new problem</b></td></tr>");
		echo("<tr><td></td><td><i>Problem description:</i></td><td>");
		echo($_SESSION["NewProblemDescription"]);
		echo("</td></tr>");
	}
	
	if(isset($_SESSION["Survey"]) && $_SESSION["Survey"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>This paper includea a Literature Survey</b></td></tr>");
		echo("<tr><td></td><td><i>Survey subject area(s):</i></td><td>");
		echo($_SESSION["SurveyDescription"]);
		echo("</td></tr>");
	}
	
	if($_SESSION["HypothesisQuantity"] > 0){
		echo("<tr><td colspan = \"3\"><b>This paper makes the following hypotheses or claims</b></td></tr>");
		for($p = 1; $p < $_SESSION["HypothesisQuantity"] + 1; $p++){
			echo("<tr><td></td><td><i>Hypothesis Name</i></td><td>");
			echo($_SESSION["HypothesisNames"][$p]);
			echo("</td></tr>");	
			
			echo("<tr><td></td><td><i>Hypothesis Description</i></td><td>");
			echo($_SESSION["HypothesisDescriptions"][$p]);
			echo("</td></tr>");
			
			echo("<tr><td></td><td><i>This hypothesis is supported by the following evidence</i></td><td>");
			echo($_SESSION["HypothesisEvidenceDescriptions"][$p]);
			echo("</td></tr>");
		}	
	}
	
	echo("</table>");
	
}

function renderRelevance(){
	?>
	<table border = "1"><tr><td colspan = "3"><h2>Relevance</h2></td></tr>
	<?
	if(isset($_SESSION["PaperRelevance"]) && $_SESSION["PaperRelevance"] != 5){
		$lookup[1] = "Definately Relevant";
		$lookup[2] = "Mostly Relevant";
		$lookup[3] = "Mostly NOT relevant";
		$lookup[4] = "Definately NOT relevant";
		echo("<tr><td><b>This paper is:</b></td><td>");
		echo($lookup[$_SESSION["PaperRelevance"]]);
		echo(" to this call for papers</td><td>User selected</td></tr>");
	}
	else{
		if(isset($_SESSION["ConferenceType"])){
			$lookup[1] = "Applied papers";
			$lookup[2] = "Theoretical papers";
			$lookup[3] = "Both theoretical and applied papers";
			echo("<tr><td><b>This call for papers is for:</b></td><td>");
			echo($lookup[$_SESSION["ConferenceType"]]);
			echo("</td><td>User selected</td></tr>");
		}
		if(isset($_SESSION["Coverage"])){
			$lookup[1] = "Solely about the call for papers core subjects";
			$lookup[2] = "Mainly about the call for papers core subjects";
			$lookup[3] = "Partly about the call for papers core subjects";
			$lookup[4] = "Only tangentially related to the call for papers core subjects";
			$lookup[5] = "Unrelated to the call for papers' core subjects";
			echo("<tr><td><b>This paper is:</b></td><td>");
			echo($lookup[$_SESSION["Coverage"]]);
			echo("</td><td>User selected</td></tr>");
		}
		if(isset($_SESSION["HypothesisQuantity"])){
			echo("<tr><td colspan = \"3\"><b>Hypotheses</b></td></tr>");
			for($x = 1; $x < $_SESSION["HypothesisQuantity"] + 1; $x++){
				$lookup[1] = "Theoretical evidence";
				$lookup[2] = "Experimental evidence";
				$lookup[3] = "Both theoretical and experimental evidence";
				echo("<tr><td><b>Hypothesis $x (");
				echo($_SESSION["HypothesisNames"][$x]);
				echo(") is justified by:</b></td><td>");
				echo($lookup[$_SESSION["HypothesisEvidenceTypes"][$x]]);
				echo("</td><td>User selected</td></tr>");
			}
		}
	}
	echo("<tr><td><b>Justification</b></td><td colspan = \"2\">");
	echo($_SESSION["RelevanceMotivation"]);
	echo("</td></tr></table>");
}


function renderSignificance(){
	?>
	<table border = "1"><tr><td colspan = "3"><h2>Significance</h2></td></tr>
	<?
	if(isset($_SESSION["Techniques"])){
		for($i = 1; $i < $_SESSION["TechniqueQuantity"] + 1; $i++){
			echo("<tr><td colspan = \"3\"><b>Technique $i</b></td></tr>");
			if(isset($_SESSION["TechniqueApplicable"][$i])){
				$lookup[1] = "Very widely applicable";
				$lookup[2] = "Quite widely applicable";
				$lookup[3] = "Not widely applicable";
				echo("<tr><td><b>This technique is:</b></td><td>");
				$results = $lookup[$_SESSION["TechniqueApplicable"][$i]];
				echo($results);
				echo("</td><td>User selection</td></tr>");
			}
			if(isset($_SESSION["TechniqueExtensionsSubstantial"][$i])){
				$lookup["yes"] = "A substantial extension to an existing technique";
				$lookup["no"] = "A minor extension to an existing technique";
				echo("<tr><td><b>This technique is:</b></td><td>");
				echo($lookup[$_SESSION["TechniqueExtensionsSubstantial"][$i]]);
				echo("</td><td>User selection</td></tr>");
			}
			if(isset($_SESSION["PreviousSimilar"][$i])){
				$lookup[0] = "Very similar to the techniques original problem";
				$lookup[1] = "Somewhat similar to the techniques original problem";
				$lookup[2] = "Very different to the techniques original problem";
				echo("<tr><td><b>The problem this technique has been applied to is :</b></td><td>");
				echo($lookup[$_SESSION["PreviousSimilar"][$i]]);
				echo("</td><td>User selection</td></tr>");
			}
			if(isset($_SESSION["RivalTechniques"][$i]) && $_SESSION["RivalTechniques"][$i] > 0){
				for($x = 1; $x < $_SESSION["RivalTechniques"][$i]; $x++){
					$lookup[1] = "Many advantages";
					$lookup[2] = "Some advantages";
					$lookup[3] = "No real advantages or disadvantages";
					$lookup[4] = "Some disadvantages";
					$lookup[5] = "Many disadvantages";
					echo("<tr><td><b>This technique provides :</b><td>");
					echo($lookup[$_SESSION["RivalTechniqueAdvantages"][$i][$x]]);
					echo(" over ");
					echo($_SESSION["RivalTechniqueNames"][$i][$x]);
					echo("</td><td>User selection</td></tr>");
				}
			}
		}
	}
	if(isset($_SESSION["Survey"])){
		echo("<tr><td colspan = \"3\"><b>Survey</b></td></tr>");
		if(isset($_SESSION["SurveyDepth"])){
			$lookup[1] = "A deep examination oif the subject area";
			$lookup[2] = "A fairly detailed review of the subject area";
			$lookup[3] = "A quite shallow or introductory look at the field";
			echo("<tr><td><b>This survey is:</b></td><td>");
			$results = $lookup[$_SESSION["SurveyDepth"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		if(isset($_SESSION["SurveyBreadth"])){
			$lookup[1] = "A very broad look at the subject area";
			$lookup[2] = "A fairly broad review of the subject area";
			$lookup[3] = "A narrow review of a specific part of the subject area";
			echo("<tr><td><b>This survey is:</b></td><td>");
			$results = $lookup[$_SESSION["SurveyBreadth"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		if(isset($_SESSION["SurveyCurrent"])){
			$lookup[1] = "Cutting edge";
			$lookup[2] = "Fairly up to datea";
			$lookup[3] = "Outdated";
			echo("<tr><td><b>This survey is:</b></td><td>");
			$results = $lookup[$_SESSION["SurveyCurrent"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		
	}
	if(isset($_SESSION["Survey"]) && $_SESSION["Survey"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>New Problem</b></td></tr>");
		if(isset($_SESSION["SurveyDepth"])){
			$lookup[1] = "A deep examination oif the subject area";
			$lookup[2] = "A fairly detailed review of the subject area";
			$lookup[3] = "A quite shallow or introductory look at the field";
			echo("<tr><td><b>This survey is:</b></td><td>");
			$results = $lookup[$_SESSION["SurveyDepth"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		if(isset($_SESSION["SurveyBreadth"])){
			$lookup[1] = "A very broad look at the subject area";
			$lookup[2] = "A fairly broad review of the subject area";
			$lookup[3] = "A narrow review of a specific part of the subject area";
			echo("<tr><td><b>This survey is:</b></td><td>");
			$results = $lookup[$_SESSION["SurveyBreadth"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		if(isset($_SESSION["SurveyCurrent"])){
			$lookup[1] = "Cutting edge";
			$lookup[2] = "Fairly up to datea";
			$lookup[3] = "Outdated";
			echo("<tr><td><b>This survey is:</b></td><td>");
			$results = $lookup[$_SESSION["SurveyCurrent"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		
	}
	if(isset($_SESSION["Problem"]) && $_SESSION["Problem"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>New Problem</b></td></tr>");
		if(isset($_SESSION["ProblemSignificant"])){
			$lookup[1] = "Very significant";
			$lookup[2] = "Significant";
			$lookup[3] = "Not significant";
			echo("<tr><td><b>This problem is:</b></td><td>");
			$results = $lookup[$_SESSION["ProblemSignificant"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
	}
	
	if(isset($_SESSION["System"]) && $_SESSION["System"] == "yes"){
		echo("<tr><td colspan = \"3\"><b>System</b></td></tr>");
		if(isset($_SESSION["SystemType"])){
			$lookup[1] = "Totally new";
			$lookup[2] = "Built by combining existing tools";
			$lookup[3] = "Is an update of a previous system";
			echo("<tr><td><b>This system is:</b></td><td>");
			$results = $lookup[$_SESSION["SystemType"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
		}
		if(isset($_SESSION["SystemType"]) && $_SESSION["SystemType"] == 3){
			$lookup[1] = "Very different from its previous version";
			$lookup[2] = "Quite different from its previous version";
			$lookup[3] = "Not very different from its previous version";
			echo("<tr><td><b>This system is:</b></td><td>");
			$results = $lookup[$_SESSION["SystemDiffers"]];
			echo($results);
			echo("</td><td>User selection</td></tr>");
			echo("<tr><td><b>This version of the system differs from the previous version in the following ways:</b></td><td colspan = \"2\">");
			echo($_SESSION["PreviousSystemDifferences"]);
			echo("</td></tr>");
		}
		if(isset($_SESSION["SystemType"]) && $_SESSION["SystemType"] == 2){
			for($p = 1; $p < $_SESSION["ToolsQuantity"]; $p++){
				$lookup[1] = "Novel";
				$lookup[2] = "Standard";
				echo("<tr><td><b>This use of tool $p (");
				echo($_SESSION["ToolNames"][$p]);
				echo(") is:</b></td><td>");
				$results = $lookup[$_SESSION["ToolNovel"][$p]];
				echo($results);
				echo("</td><td>User selection</td></tr>");
			}
		}
	}
	echo("</table>");
}


function renderOriginality(){
	?>
	<table border = "1">
	<tr><td colspan = "3"><h2>Originality</h2></td></tr>
	<?
	if(isset($_SESSION["PaperOriginality"]) && $_SESSION["PaperOriginality"] != 5){
		$lookup[1] = "Trailblazing";
		$lookup[2] = "One step ahead of the pack";
		$lookup[3] = "Yet another paper about...";
		$lookup[4] = "Its all been said many times before";
		echo("<tr><td><b>Overall Result:</b></td><td colspan = \"2\">");
		echo($lookup[$_SESSION["PaperOriginality"]]);
		echo("</td>");
	}
	else{
		if(isset($_SESSION["PreviouslyPublished"])){
			$lookup[1] = "Yes Verbatim";
			$lookup[2] = "A previous version has been published before";
			$lookup[3] = "This is a rewrite of a previous paper";
			$lookup[4] = "Not to my knowledge";
			echo("<tr><td><b>Has this paper been published before?</b></td><td>");
			echo($lookup[$_SESSION["PreviouslyPublished"]]);
			echo("</td><td>User Selected</td></tr>");
		}
		if(isset($_SESSION["PreviousSimilar"])){
			$lookup[1] = "Yes";
			$lookup[2] = "Yes but this paper was developed in isolation";
			$lookup[3] = "Not to my knowledge";
			echo("<tr><td><b>Has similar work been published before?</b></td><td>");
			echo($lookup[$_SESSION["PreviousSimilar"]]);
			echo("</td><td>User Selected</td></tr>");
		}
		if(isset($_SESSION["OriginalitySystems"])){
			$lookup[1] = "Many";
			$lookup[2] = "Some";
			$lookup[3] = "None";
			echo("<tr><td><b>How many similar systems exist?</b></td><td>");
			echo($lookup[$_SESSION["OriginalitySystems"]]);
			echo("</td><td>User Selected</td></tr>");
		}
		if(isset($_SESSION["OriginalityProblem"])){
			$lookup[1] = "Completely Different";
			$lookup[2] = "Quite different";
			$lookup[3] = "Marginally Different";
			$lookup[3] = "Not different at all";
			echo("<tr><td><b>How many similar systems exist?</b></td><td>");
			echo($lookup[$_SESSION["OriginalityProblem"]]);
			echo("</td><td>User Selected</td></tr>");
		}
	}
	echo("<tr><td><b>Justification</b></td><td colspan = \"2\">");
	echo($_SESSION["OriginalityMotivation"]);
	echo("</td></tr></table>");
	
	
}

function presentationLogic(){
	$_SESSION["kb"]->modus_ponens();
	//echo("<pre><h6>");
	//print_r($_SESSION["kb"]);
	//echo("</h6></pre>");
	
	$fact = new fact("recommendation", array(new atom("english")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	//echo("%%<pre>");
	//print_r($node);
	//echo("</pre>%%");
	$justifications = count($node->inList);
	//echo("**$justifications**");
	if($justifications == 0){
		$_SESSION["recommendations"]["english"] = "poor";
		$fact = new fact("recommendation", array( new atom("english"), new atom("poor")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications == 1){
		$_SESSION["recommendations"]["english"] = "average";
		$fact = new fact("recommendation", array( new atom("english"), new atom("average")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications == 2){
		$_SESSION["recommendations"]["english"] = "good";
		$fact = new fact("recommendation", array( new atom("english"), new atom("good")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications == 3){
		$_SESSION["recommendations"]["english"] = "excellent";
		$fact = new fact("recommendation", array( new atom("english"), new atom("excellent")));
		$_SESSION["kb"]->add_fact($fact);
	}
	
	$fact = new fact("recommendation", array( new atom("organisation")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	$justifications = count($node->inList);
	//echo("**$justifications**");
	if($justifications < 2){
		$_SESSION["recommendations"]["organisation"] = "poor";
		$fact = new fact("recommendation", array( new atom("organisation"), new atom("poor")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications < 5){
		$_SESSION["recommendations"]["organisation"] = "average";
		$fact = new fact("recommendation", array( new atom("organisation"), new atom("average")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications < 8){
		$_SESSION["recommendations"]["organisation"] = "good";
		$fact = new fact("recommendation", array( new atom("organisation"), new atom("good")));
		$_SESSION["kb"]->add_fact($fact);
	}
	else{
		$_SESSION["recommendations"]["organisation"] = "excellent";
		$fact = new fact("recommendation", array( new atom("organisation"), new atom("excellent")));
		$_SESSION["kb"]->add_fact($fact);
	}
	
	$fact = new fact("recommendation", array( new atom("readability")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	$justifications = count($node->inList);
	//echo("**$justifications**");
	if($justifications < 1){
		$_SESSION["recommendations"]["readability"] = "poor";
		$fact = new fact("recommendation", array( new atom("readability"), new atom("poor")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications == 2){
		$_SESSION["recommendations"]["readability"] = "average";
		$fact = new fact("recommendation", array( new atom("readability"), new atom("average")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications == 3){
		$_SESSION["recommendations"]["readability"] = "good";
		$fact = new fact("recommendation", array( new atom("readability"), new atom("good")));
		$_SESSION["kb"]->add_fact($fact);
	}
	elseif($justifications == 4){
		$_SESSION["recommendations"]["readability"] = "excellent";
		$fact = new fact("recommendation", array( new atom("readability"), new atom("excellent")));
		$_SESSION["kb"]->add_fact($fact);
	}
	
	$_SESSION["kb"]->modus_ponens();
	
	
	$fact = new fact("recommendation", array( new atom("presentation"), new atom("poor")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	$maxCand = "poor";
	$maxVal = count($node->inList);
	
	$fact = new fact("recommendation", array( new atom("presentation"), new atom("average")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	if(count($node->inList) >= $maxVal){
		$maxCand = "average";
		$maxVal = count($node->inList);
	}
	
	$fact = new fact("recommendation", array( new atom("presentation"), new atom("good")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	if(count($node->inList) >= $maxVal){
		$maxCand = "good";
		$maxVal = count($node->inList);
	}
	
	$fact = new fact("recommendation", array( new atom("presentation"), new atom("excellent")));
	$node = $_SESSION["kb"]->jtms->jtms_find_node($fact);
	if(count($node->inList) >= $maxVal){
		$maxCand = "excellent";
		$maxVal = count($node->inList);
	}
	
	$_SESSION["recommendations"]["presentation"] = $maxCand;
	$fact = new fact("finalRecommendation", array( new atom("presentation"), new atom($maxCand)));
	$_SESSION["kb"]->add_fact($fact);
}

function renderPresentation(){
	?>
	<table border = "1">
	<tr><td colspan = "3"><h2>Presentation</h2></td></tr>
	<tr><td><b>Overall Result:</b></td>
	<? if(isset($_SESSION["Presentation"]) && $_SESSION["Presentation"] != 5){
		echo("<td>");
		$result = $_SESSION["lookup"][$_SESSION["Presentation"]];
		echo($result);
		echo("</td><td>User selected</td></tr>");
	}
	elseif(isset($_SESSION["recommendations"]["presentation"])){
		echo("<td>");
		$result = $_SESSION["recommendations"]["presentation"];
		echo($result);
		echo("</td><td>Recomendation</td></tr>");
		
		if(isset($_SESSION["Organised"]) && $_SESSION["Organised"] != 5){
			echo("<tr><td><b>Organisation:</b></td><td>");
			$result = $_SESSION["lookup"][$_SESSION["Organised"]];
			echo($result);
			echo("</td><td>User selected</td></tr>");
		}
		elseif(isset($_SESSION["recommendations"]["organisation"])){
			echo("<tr><td><b>Organisation:</b></td><td>");
			$result = $_SESSION["recommendations"]["organisation"];
			echo($result);
			echo("</td><td>Recomendation</td></tr>");
		}
		
		if(isset($_SESSION["English"]) && $_SESSION["English"] != 5){
			echo("<tr><td><b>English:</b></td><td>");
			$result = $_SESSION["lookup"][$_SESSION["English"]];
			echo($result);
			echo("</td><td>User selected</td></tr>");
		}
		elseif(isset($_SESSION["recommendations"]["english"])){
			echo("<tr><td><b>English:</b></td><td>");
			$result = $_SESSION["recommendations"]["english"];
			echo($result);
			echo("</td><td>Recomendation</td></tr>");
		}
		
		if(isset($_SESSION["Readability"]) && $_SESSION[$_SESSION["Readability"]] != 5){
			echo("<tr><td><b>Readability:</b></td><td>");
			$result = $_SESSION["lookup"][$_SESSION["Readability"]];
			echo($result);
			echo("</td><td>User selected</td></tr>");
		}
		elseif(isset($_SESSION["recommendations"]["readability"])){
			echo("<tr><td><b>English:</b></td><td>");
			$result = $_SESSION["recommendations"]["readability"];
			echo($result);
			echo("</td><td>Recomendation</td></tr>");
		}
		
		if(isset($_SESSION["Bibliography"]) && $_SESSION["Bibliography"] != 0){
			$result = $_SESSION["lookup"][$_SESSION["Bibliography"]];
			if($_SESSION["Bibliography"] == 5){
				$result = "awful";
			}
			echo("<tr><td><b>Bibliography:</b></td><td>");
			echo($result);
			echo("</td><td>User selected</td></tr>");
		}
		
		
		
	}
	echo("<tr><td><b>Justification</b></td><td colspan = \"2\">");
	echo($_SESSION["PresentationJustification"]);
	echo("</td></tr>");
	?>
	</table>
	<?
}
//echo("<pre>");
//print_r($_SESSION["recommendations"]);
//echo("</pre>");
//$Rules = "eng(*A*, yes) => recommendation(english);";
//$Rules .= "org(*A*, yes) => recommendation(organisation);";
//$Rules .= "read(*A*, yes) => recommendation(readability);";
?>